<?php

namespace Drupal\private_message_nodejs\Form;

use Drupal\Core\Form\FormStateInterface;
use Drupal\private_message\Form\PrivateMessageForm;
use Drupal\private_message_nodejs\Ajax\PrivateMessageNodejsTriggerInboxUpdateCommand;
use Drupal\private_message_nodejs\Ajax\PrivateMessageNodejsTriggerNewMessagesCommand;
use Drupal\private_message_nodejs\Ajax\PrivateMessageNodejsTriggerUnreadThreadCountUpdateCommand;

/**
 * Defines the private message form.
 */
class PrivateMessageNodejsForm extends PrivateMessageForm {

  /**
   * Ajax callback for the PrivateMessageForm.
   */
  public function ajaxCallback(array $form, FormStateInterface $formState) {

    $response = parent::ajaxCallback($form, $formState);
    $response->addCommand(new PrivateMessageNodejsTriggerNewMessagesCommand());

    $uids = [];
    foreach ($formState->get('thread_members') as $member) {
      $uids[] = $member->id();
    }

    if (!empty($uids)) {
      $response->addCommand(new PrivateMessageNodejsTriggerInboxUpdateCommand($uids));
      $response->addCommand(new PrivateMessageNodejsTriggerUnreadThreadCountUpdateCommand($uids));
    }

    return $response;
  }

}
