<?php

namespace Drupal\private_message_nodejs\Plugin\PrivateMessageConfigForm;

use Drupal\Core\Form\FormStateInterface;
use Drupal\private_message\Plugin\PrivateMessageConfigForm\PrivateMessageConfigFormBase;
use Drupal\private_message\Plugin\PrivateMessageConfigForm\PrivateMessageConfigFormPluginInterface;

/**
 * Adds Private Message Nodejse settings to the Private Message settings page.
 *
 * @PrivateMessageConfigForm(
 *   id = "private_message_node_js_settings",
 *   name = @Translation("Private Message Nodejs settings"),
 * )
 */
class PrivateMessageNodeJsPrivateMessageConfigForm extends PrivateMessageConfigFormBase implements PrivateMessageConfigFormPluginInterface {

  /**
   * {@inheritdoc}
   */
  public function buildForm(FormStateInterface $formState) {

    $config = $this->configFactory->get('private_message_nodejs.settings');

    $form['nodejs_url'] = [
      '#type' => 'url',
      '#title' => $this->t('Nodejs url'),
      '#description' => $this->t('The URL at which the Nodejs server can be accessed'),
      '#default_value' => $config->get('nodejs_url'),
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array $values) {

    $this->configFactory->getEditable('private_message_nodejs.settings')
      ->set('nodejs_url', $values['nodejs_url'])
      ->save();
  }

}
